# ==================================================================
# Plugins::Check_If_Allowed - Auto Generated Program Module
#
#   Plugins::Check_If_Allowed
#   Author  : Andy
#   Version : 1
#   Updated : Sat Aug  2 04:23:58 2008
#
# ==================================================================
#

package Plugins::Check_If_Allowed;
# ==================================================================

use strict;
use GT::Base;
use GT::Plugins qw/STOP CONTINUE/;
use Links qw/:objects/;

# Inherit from base class for debug and error methods
@Plugins::Check_If_Allowed::ISA = qw(GT::Base);

# Your code begins here.


# PLUGIN HOOKS
# ===================================================================


sub add_link_check {
# -----------------------------------------------------------------------------
# This subroutine will be called whenever the hook 'add_link' is run.  You
# should call $PLG->action(STOP) if you don't want the regular
# 'add_link' code to run, otherwise the code will continue as normal.
#
    my (@args) = @_;
 
    my @cats = $IN->param('CatLinks.CategoryID');
#    use Data::Dumper;
#    print Dumper(@cats);

    my @errors;
    foreach (@cats) {
      if ($DB->table('Category')->count( { ID => $_, Can_Add => 1 } ) < 1) {
         my $cat_name = $DB->table('Category')->select( ['Full_Name'], { ID => $_ } )->fetchrow;
         push @errors, qq|Sorry, you are not allowed to add to $cat_name|;
      }
    }
    
    if ($errors[0]) { 
     print $IN->header;
     print Links::SiteHTML::display('add',{ error => qq|<ul><li>| . join('</li>',@errors) . q|</ul>| } );
     exit;
    }

    return @args;
}

# Always end with a 1.
1;
