# ==================================================================
# Plugins::Check_If_Allowed - Auto Generated Install Module
#
#   Plugins::Check_If_Allowed
#   Author  : Andy
#   Version : 1
#   Updated : Sat Aug  2 04:23:58 2008
#
# ==================================================================
#

package Plugins::Check_If_Allowed;
# ==================================================================
use strict;
use vars  qw/$VERSION $DEBUG $NAME $META/;
use GT::Base;
use GT::Plugins qw/STOP CONTINUE/;
use Links qw/:objects/;

$VERSION = '1';
$DEBUG   = 0;
$NAME    = 'Check_If_Allowed';
# Inhert from base class for debug and error methods
@Plugins::Check_If_Allowed::ISA = qw(GT::Base);

$META = {
    'author' => 'Andy',
    'description' => 'Lets you set a Yes/No for Can_Add field - and if they select a category that they are not allowed to add to - it will give an error.',
    'license' => 'Freeware',
    'prog_ver' => '3.2.0',
    'url' => 'http://www.ultranerds.com/',
    'version' => '1'
};


sub pre_install {
# -----------------------------------------------------------------------------
# This function displays an HTML formatted message that will display any
# instructions/information to the user before they install the plugin.
#
    my $inst_msg = '';

    return $inst_msg;
}

sub pre_uninstall {
# -----------------------------------------------------------------------------
# This function displays an HTML formatted message that will display any
# instructions/information to the user before they remove the plugin.
#
    my $uninst_msg = '';

    return $uninst_msg;
}

sub install {
# -----------------------------------------------------------------------------
# This function does the actual installation.  Its first argument is a plugin
# manager which you can use to register hooks, install files, add menu options,
# etc.  The second argument is a GT::Tar object which you can use to access any
# files in your plugin module.
#
# You should return an HTML formatted string that will be displayed to the
# user.
#
# If there is an error, return undef, and set the error message in
# $Plugins::Check_If_Allowed::error
#
    my ($mgr, $tar) = @_;
    
    my $exists = 0;

    if (exists $DB->table('Category')->cols->{'Can_Add'}) { $exists = 1; }
   
    if (!$exists) {       
             my $editor = $DB->editor ('Category');
                $editor->add_col ('Can_Add', {
                form_display => 'Users Can Add Links to?',
                form_size => '1',
                form_type => 'SELECT',
                not_null => '0',
                default => '0',
       	        form_names   => [ '1','0' ],
                form_values  => [ 'Yes','No' ],
                type => 'INT' });
    }

    $exists ? 
       print "No need to add \"Can_Add\" field, as it already exists... <BR>":
       print "Added \"Can_Add\" link option... <BR>";

    $mgr->install_hooks('Check_If_Allowed', [['add_link', 'PRE', 'Plugins::Check_If_Allowed::add_link_check', '']]);
    
    return "The plugin has been successfully installed!";
}

sub uninstall {
# -----------------------------------------------------------------------------
# This function removes the plugin.  Its first argument is also a plugin
# manager which you can use to register hooks, install files, add menu options,
# etc. You should return an HTML formatted string that will be displayed to the
# user.
#
# If there is an error, return undef, and set the error message in
# $Plugins::Check_If_Allowed::error
#
    my $mgr = shift;
    
    $mgr->uninstall_hooks('Check_If_Allowed', [['add_link', 'PRE', 'Plugins::Check_If_Allowed::add_link_check', '']]);
    ;
    return "The plugin has been successfully removed!";
}

1;
